Loading...
Searching...
No Matches
opengv::absolute_pose::AbsoluteAdapterBase Class Referenceabstract

`#include <AbsoluteAdapterBase.hpp>`

Inheritance diagram for opengv::absolute_pose::AbsoluteAdapterBase:

## Public Member Functions

EIGEN_MAKE_ALIGNED_OPERATOR_NEW | AbsoluteAdapterBase ()
| Constructor.
| AbsoluteAdapterBase (const opengv::rotation_t &R)
| Constructor.
| AbsoluteAdapterBase (const opengv::translation_t &t, const opengv::rotation_t &R)
| Constructor.
virtual | ~AbsoluteAdapterBase ()
| Destructor.
virtual opengv::bearingVector_t | getBearingVector (size_t index) const =0
| Retrieve the bearing vector of a correspondence.
virtual double | getWeight (size_t index) const =0
| Retrieve the weight of a correspondence. The weight is supposed to reflect the quality of a correspondence, and typically is between 0 and 1.
virtual opengv::translation_t | getCamOffset (size_t index) const =0
| Retrieve the position of a camera of a correspondence seen from the viewpoint origin.
virtual opengv::rotation_t | getCamRotation (size_t index) const =0
| Retrieve the rotation from a camera of a correspondence to the viewpoint origin.
virtual opengv::point_t | getPoint (size_t index) const =0
| Retrieve the world point of a correspondence.
virtual size_t | getNumberCorrespondences () const =0
| Retrieve the number of correspondences.
opengv::translation_t | gett () const
| Retrieve the prior or known value for the position.
void | sett (const opengv::translation_t &t)
| Set the prior or known value for the position.
opengv::rotation_t | getR () const
| Retrieve the prior or known value for the rotation.
void | setR (const opengv::rotation_t &R)
| Set the prior or known value for the rotation.

## Protected Attributes

opengv::translation_t | _t
opengv::rotation_t | _R

## Detailed Description

The AbsoluteAdapterBase is the base-class for the visitors to the central and non-central absolute pose algorithms. It provides a unified interface to opengv-methods to access bearing-vectors, world points, priors or known variables for the absolute pose, and the multi-camera configuration in the non-central case. Derived classes may hold the data in any user-specific format, and adapt to opengv-types.

## Constructor & Destructor Documentation

## AbsoluteAdapterBase() [1/2]

opengv::absolute_pose::AbsoluteAdapterBase::AbsoluteAdapterBase | ( | const opengv::rotation_t & | R | ) |

inline

Constructor.

Parameters

  [in] | R | A prior or known value for the rotation from the viewpoint to the world frame.

## AbsoluteAdapterBase() [2/2]

opengv::absolute_pose::AbsoluteAdapterBase::AbsoluteAdapterBase | ( | const opengv::translation_t & | t,
|  | const opengv::rotation_t & | R )

inline

Constructor.

Parameters

  [in] | t | A prior or known value for the position of the viewpoint seen from the world frame.
  [in] | R | A prior or known value for the rotation from the viewpoint to the world frame.

## Member Function Documentation

## getBearingVector()

virtual opengv::bearingVector_t opengv::absolute_pose::AbsoluteAdapterBase::getBearingVector | ( | size_t | index | ) | const

pure virtual

Retrieve the bearing vector of a correspondence.

Parameters

  [in] | index | The serialized index of the correspondence.

Returns
  The corresponding bearing vector.

Implemented in opengv::absolute_pose::AbsoluteMultiAdapterBase, opengv::absolute_pose::CentralAbsoluteAdapter, opengv::absolute_pose::MACentralAbsolute, opengv::absolute_pose::MANoncentralAbsolute, and opengv::absolute_pose::NoncentralAbsoluteAdapter.

## getCamOffset()

virtual opengv::translation_t opengv::absolute_pose::AbsoluteAdapterBase::getCamOffset | ( | size_t | index | ) | const

pure virtual

Retrieve the position of a camera of a correspondence seen from the viewpoint origin.

Parameters

  [in] | index | The serialized index of the correspondence.

Returns
  The position of the corresponding camera seen from the viewpoint origin.

Implemented in opengv::absolute_pose::AbsoluteMultiAdapterBase, opengv::absolute_pose::CentralAbsoluteAdapter, opengv::absolute_pose::MACentralAbsolute, opengv::absolute_pose::MANoncentralAbsolute, and opengv::absolute_pose::NoncentralAbsoluteAdapter.

## getCamRotation()

virtual opengv::rotation_t opengv::absolute_pose::AbsoluteAdapterBase::getCamRotation | ( | size_t | index | ) | const

pure virtual

Retrieve the rotation from a camera of a correspondence to the viewpoint origin.

Parameters

  [in] | index | The serialized index of the correspondence.

Returns
  The rotation from the corresponding camera back to the viewpoint origin.

Implemented in opengv::absolute_pose::AbsoluteMultiAdapterBase, opengv::absolute_pose::CentralAbsoluteAdapter, opengv::absolute_pose::MACentralAbsolute, opengv::absolute_pose::MANoncentralAbsolute, and opengv::absolute_pose::NoncentralAbsoluteAdapter.

## getNumberCorrespondences()

virtual size_t opengv::absolute_pose::AbsoluteAdapterBase::getNumberCorrespondences | ( |  | ) | const

pure virtual

Retrieve the number of correspondences.

Returns
  The number of correspondences.

Implemented in opengv::absolute_pose::AbsoluteMultiAdapterBase, opengv::absolute_pose::CentralAbsoluteAdapter, opengv::absolute_pose::MACentralAbsolute, opengv::absolute_pose::MANoncentralAbsolute, and opengv::absolute_pose::NoncentralAbsoluteAdapter.

## getPoint()

virtual opengv::point_t opengv::absolute_pose::AbsoluteAdapterBase::getPoint | ( | size_t | index | ) | const

pure virtual

Retrieve the world point of a correspondence.

Parameters

  [in] | index | The serialized index of the correspondence.

Returns
  The corresponding world point.

Implemented in opengv::absolute_pose::AbsoluteMultiAdapterBase, opengv::absolute_pose::CentralAbsoluteAdapter, opengv::absolute_pose::MACentralAbsolute, opengv::absolute_pose::MANoncentralAbsolute, and opengv::absolute_pose::NoncentralAbsoluteAdapter.

## getR()

opengv::rotation_t opengv::absolute_pose::AbsoluteAdapterBase::getR | ( |  | ) | const

inline

Retrieve the prior or known value for the rotation.

Returns
  The prior or known value for the rotation.

## gett()

opengv::translation_t opengv::absolute_pose::AbsoluteAdapterBase::gett | ( |  | ) | const

inline

Retrieve the prior or known value for the position.

Returns
  The prior or known value for the position.

## getWeight()

virtual double opengv::absolute_pose::AbsoluteAdapterBase::getWeight | ( | size_t | index | ) | const

pure virtual

Retrieve the weight of a correspondence. The weight is supposed to reflect the quality of a correspondence, and typically is between 0 and 1.

Parameters

  [in] | index | The serialized index of the correspondence.

Returns
  The corresponding weight.

Implemented in opengv::absolute_pose::AbsoluteMultiAdapterBase, opengv::absolute_pose::CentralAbsoluteAdapter, opengv::absolute_pose::MACentralAbsolute, opengv::absolute_pose::MANoncentralAbsolute, and opengv::absolute_pose::NoncentralAbsoluteAdapter.

## setR()

void opengv::absolute_pose::AbsoluteAdapterBase::setR | ( | const opengv::rotation_t & | R | ) |

inline

Set the prior or known value for the rotation.

Parameters

  [in] | R | The prior or known value for the rotation.

## sett()

void opengv::absolute_pose::AbsoluteAdapterBase::sett | ( | const opengv::translation_t & | t | ) |

inline

Set the prior or known value for the position.

Parameters

  [in] | t | The prior or known value for the position.

## Member Data Documentation

## _R

opengv::rotation_t opengv::absolute_pose::AbsoluteAdapterBase::_R

protected

The prior or known value for the rotation from the viewpoint back to the world frame. Initialized to identity if not provided.

## _t

opengv::translation_t opengv::absolute_pose::AbsoluteAdapterBase::_t

protected

The prior or known value for the position of the viewpoint seen from the world frame. Initialized to zero if not provided.

The documentation for this class was generated from the following file:

- include/opengv/absolute_pose/AbsoluteAdapterBase.hpp